#include <jni.h>
#include "JTextCat.h"
#include "textcat.h"
#include <stdio.h>
#include <unistd.h>


JNIEXPORT jstring JNICALL Java_JTextCat_getversion (JNIEnv *env, jobject obj)
{
	return (*env)->NewStringUTF(env, textcat_Version());
}


JNIEXPORT jstring JNICALL Java_JTextCat_classify (JNIEnv *env, jobject obj, jstring text, jstring configdir, jstring configfile)
{

	void *h;
	const char *str1 = (*env)->GetStringUTFChars(env,text,0);
	const char *str2 = (*env)->GetStringUTFChars(env,configdir,0);
	const char *str3 = (*env)->GetStringUTFChars(env,configfile,0);
	char *result;
	const char *str4;
	
	//Goto the Configdir
	chdir (str2);

	//Open the Configfile
        h = textcat_Init( str3);
        if ( !h ) {
                printf("Unable to init. Aborting.\n");
                exit(-1);
        }

	result = textcat_Classify( h, str1, strlen(str1)+1 );
        textcat_Done(h);

	str4=(*env)->NewStringUTF(env,result);
	(*env)->ReleaseStringUTFChars(env,text,str1);
	(*env)->ReleaseStringUTFChars(env,configdir,str2);
	(*env)->ReleaseStringUTFChars(env,configfile,str3);
	return (str4);

}
